Subject: Re: bug#22164: 25.0.50; Turning off blinking cursor mode makes menu tooltips behave erratically

From: Eli Zaretskii <[email-masked]>
Date: Sun, 13 Dec 2015 20:10:58 +0200

> Date: Sun, 13 Dec 2015 18:56:27 +0100
> From: martin rudalics <[email-masked]>
> 
> With emacs -Q evaluate (blink-cursor-mode -1).  Click the "File" entry
> on the menu bar.  When I now move the mouse from one menu entry to
> another it takes approximately 8 seconds until the tooltip is removed
> from the previous entry and shown at the current one.
> 
> Reproducible at least since Emacs 24.2 and likely a Windows-only bug.
> It might be related to this part of ‘blink-cursor-timer-function’
> 
>    ;; Suspend counting blinks when the w32 menu-bar menu is displayed,
>    ;; since otherwise menu tooltips will behave erratically.
>    (or (and (fboundp 'w32--menu-bar-in-use)
> 	   (w32--menu-bar-in-use))
>        (setq blink-cursor-blinks-done (1+ blink-cursor-blinks-done)))
> 
> but I cannot imagine how that can have any effect when cursor blinking
> is turned off.

It's a known problem, and I don't know how to fix it (if a fix exists
at all).  We need redisplay to update the menu tooltips on Windows,
and without the blinking cursor there's no redisplay.